import MapmyIndiaMaps
import MapmyIndiaAnnotationExtension

/*
 * The mapping is based on the values defined here:
 *  https://docs.mapbox.com/android/api/map-sdk/8.4.0/constant-values.html
 */

class Constants {
    static let symbolIconAnchorMapping = [
        "center": MGLIconAnchor.center,
        "left": MGLIconAnchor.left,
        "right": MGLIconAnchor.right,
        "top": MGLIconAnchor.top,
        "bottom": MGLIconAnchor.bottom,
        "top-left": MGLIconAnchor.topLeft,
        "top-right": MGLIconAnchor.topRight,
        "bottom-left": MGLIconAnchor.bottomLeft,
        "bottom-right": MGLIconAnchor.bottomRight,
    ]

    static let symbolTextJustificationMapping = [
        "auto": MGLTextJustification.auto,
        "center": MGLTextJustification.center,
        "left": MGLTextJustification.left,
        "right": MGLTextJustification.right,
    ]

    static let symbolTextAnchorMapping = [
        "center": MGLTextAnchor.center,
        "left": MGLTextAnchor.left,
        "right": MGLTextAnchor.right,
        "top": MGLTextAnchor.top,
        "bottom": MGLTextAnchor.bottom,
        "top-left": MGLTextAnchor.topLeft,
        "top-right": MGLTextAnchor.topRight,
        "bottom-left": MGLTextAnchor.bottomLeft,
        "bottom-right": MGLTextAnchor.bottomRight,
    ]

    static let symbolTextTransformationMapping = [
        "none": MGLTextTransform.none,
        "lowercase": MGLTextTransform.lowercase,
        "uppercase": MGLTextTransform.uppercase,
    ]

    static let lineJoinMapping = [
        "bevel": MGLLineJoin.bevel,
        "miter": MGLLineJoin.miter,
        "round": MGLLineJoin.round,
    ]

    static let symbolIconAnchorMappingString = [
        MGLIconAnchor.center: "center",
        MGLIconAnchor.left: "left",
        MGLIconAnchor.right: "right",
        MGLIconAnchor.top: "top",
        MGLIconAnchor.bottom: "bottom",
        MGLIconAnchor.topLeft: "top-left",
        MGLIconAnchor.topRight: "top-right",
        MGLIconAnchor.bottomLeft: "bottom-left",
        MGLIconAnchor.bottomRight: "bottom-right"
    ]

    static let symbolTextJustificationMappingString = [
        MGLTextJustification.auto: "auto",
        MGLTextJustification.center: "center",
        MGLTextJustification.left: "left",
        MGLTextJustification.right: "right"
    ]

    static let symbolTextAnchorMappingString = [
        MGLTextAnchor.center: "center",
        MGLTextAnchor.left: "left",
        MGLTextAnchor.right: "right",
        MGLTextAnchor.top: "top",
        MGLTextAnchor.bottom: "bottom",
        MGLTextAnchor.topLeft: "top-left",
        MGLTextAnchor.topRight: "top-right",
        MGLTextAnchor.bottomLeft: "bottom-left",
        MGLTextAnchor.bottomRight: "bottom-right"
    ]

    static let symbolTextTransformationMappingString = [
        MGLTextTransform.none: "none",
        MGLTextTransform.lowercase: "lowercase",
        MGLTextTransform.uppercase: "uppercase"
    ]

    static let lineJoinMappingString = [
        MGLLineJoin.bevel: "bevel",
        MGLLineJoin.miter: "miter",
        MGLLineJoin.round: "round"
    ]
}
