part of mapmyindia_gl;

class MapmyIndiaGeoAnalyticsList {
  final String api;
  final String geoBoundType;
  final List<String> geoBound;
  final String attributes;

  MapmyIndiaGeoAnalyticsList(
      this.api, this.geoBoundType, this.geoBound, this.attributes);

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> optionsMap = <String, dynamic>{};

    void addIfNonNull(String fieldName, dynamic value) {
      if (value != null) {
        optionsMap[fieldName] = value;
      }
    }

    addIfNonNull('api', this.api);
    addIfNonNull('geoBoundType', this.geoBoundType);
    addIfNonNull('geoBound', this.geoBound);
    addIfNonNull('attributes', this.attributes);
    return optionsMap;
  }

  Future<GeoAnalyticsListResponse?> callGeoAnalyticsList() async {
    try {
      String? result = await restApi.geoAnalyticsList(toJson());
      return result != null
          ? GeoAnalyticsListResponse.fromMap(json.decode(result))
          : null;
    } on PlatformException catch (e) {
      return Future.error(e);
    }
  }
}
