part of mapmyindia_gl;

class MapmyIndiaRoadTrafficDetail {
  final LatLng location;
  final int? radius;

  MapmyIndiaRoadTrafficDetail({required this.location, this.radius});

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> optionsMap = <String, dynamic>{};

    void addIfNonNull(String fieldName, dynamic value) {
      if (value != null) {
        optionsMap[fieldName] = value;
      }
    }

    addIfNonNull('location', this.location.toJson());
    addIfNonNull('radius', this.radius);
    return optionsMap;
  }

  Future<TrafficRoadDetailResponse?> roadTrafficDetail() async {
    try {
      String? result = await restApi.roadTrafficDetail(toJson());
      return result != null
          ? TrafficRoadDetailResponse.fromMap(json.decode(result))
          : null;
    } on PlatformException catch (e) {
      return Future.error(e);
    }
  }
}
