part of mapmyindia_gl;

class TrafficRoadDetailResponse {
  int? responseCode;
  String? creationTime;
  TrafficRoadDetailResult? result;

  static TrafficRoadDetailResponse fromMap(Map<String, dynamic> map) {
    TrafficRoadDetailResponse trafficRoadDetailResponse =
        TrafficRoadDetailResponse();
    if (map.containsKey('result')) {
      trafficRoadDetailResponse.result = TrafficRoadDetailResult.fromMap(
          map['result'] as Map<String, dynamic>);
    }
    trafficRoadDetailResponse.responseCode = map['responseCode'];
    trafficRoadDetailResponse.creationTime = map['creationTime'];
    return trafficRoadDetailResponse;
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> map = <String, dynamic>{};

    void addIfNonNull(String fieldName, dynamic value) {
      if (value != null) {
        map[fieldName] = value;
      }
    }

    addIfNonNull('result', result?.toJson());
    addIfNonNull('responseCode', responseCode);
    addIfNonNull('creationTime', creationTime);
    return map;
  }
}

class TrafficRoadDetailResult {

  String? name;
  String? routeNumber;
  bool? isOneWay;
  int? averageSpeed;
  int? speedLimit;
  String? formOfWay;
  String? roadClass;
  bool? isMultiCarriageWay;
  bool? isDividerExist;
  int? numberOfLanes;
  bool? isShoulderLaneExist;
  String? owner;
  double? distance;
  String? city;
  String? district;
  String? state;
  String? geometry;
  String? trafficStatus;
  int? trafficType;

  static TrafficRoadDetailResult fromMap(Map<String, dynamic> map) {
    TrafficRoadDetailResult trafficRoadDetailResult = TrafficRoadDetailResult();
    trafficRoadDetailResult.name = map['name'];
    trafficRoadDetailResult.routeNumber = map['routeNo'];
    trafficRoadDetailResult.isOneWay = map['oneway'];
    trafficRoadDetailResult.averageSpeed = map['avg_spd'];
    trafficRoadDetailResult.speedLimit = map['spd_lmt'];
    trafficRoadDetailResult.formOfWay = map['formOfWay'];
    trafficRoadDetailResult.roadClass = map['roadClass'];
    trafficRoadDetailResult.isMultiCarriageWay = map['multi_cw'];
    trafficRoadDetailResult.isDividerExist = map['divider'];
    trafficRoadDetailResult.numberOfLanes = map['numOfLanes'];
    trafficRoadDetailResult.isShoulderLaneExist = map['shoulder'];
    trafficRoadDetailResult.owner = map['owner'];
    trafficRoadDetailResult.distance = map['distance'];
    trafficRoadDetailResult.city = map['city'];
    trafficRoadDetailResult.district = map['district'];
    trafficRoadDetailResult.state = map['state'];
    trafficRoadDetailResult.geometry = map['geometry'];
    trafficRoadDetailResult.trafficStatus = map['trafficStatus'];
    trafficRoadDetailResult.trafficType = map['trafficType'];
    return trafficRoadDetailResult;
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> map = <String, dynamic>{};

    void addIfNonNull(String fieldName, dynamic value) {
      if (value != null) {
        map[fieldName] = value;
      }
    }

    addIfNonNull('name', name);
    addIfNonNull('routeNo', routeNumber);
    addIfNonNull('oneway', isOneWay);
    addIfNonNull('avg_spd', averageSpeed);
    addIfNonNull('spd_lmt', speedLimit);
    addIfNonNull('formOfWay', formOfWay);
    addIfNonNull('roadClass', roadClass);
    addIfNonNull('multi_cw', isMultiCarriageWay);
    addIfNonNull('divider', isDividerExist);
    addIfNonNull('numOfLanes', numberOfLanes);
    addIfNonNull('shoulder', isShoulderLaneExist);
    addIfNonNull('owner', owner);
    addIfNonNull('distance', distance);
    addIfNonNull('city', city);
    addIfNonNull('district', district);
    addIfNonNull('state', state);
    addIfNonNull('geometry', geometry);
    addIfNonNull('trafficStatus', trafficStatus);
    addIfNonNull('trafficType', trafficType);
    return map;
  }
}
