import 'package:flutter/services.dart';

final MethodChannel _globalChannel =
    MethodChannel('plugins.flutter.io/mapmyindia_gl');

Future<void> setRestAPIKey(String key) async {
  await _globalChannel.invokeMethod(
    'setRestAPIKey',
    <String, dynamic>{
      'restAPIKey': key,
    },
  );
}

Future<void> setMapSDKKey(String key) async {
  await _globalChannel.invokeMethod(
    'setMapSDKKey',
    <String, dynamic>{
      'mapSDKKey': key,
    },
  );
}

Future<void> setAtlasClientId(String key) async {
  await _globalChannel.invokeMethod(
    'setAtlasClientId',
    <String, dynamic>{
      'atlasClientId': key,
    },
  );
}

Future<void> setAtlasClientSecret(String key) async {
  await _globalChannel.invokeMethod(
    'setAtlasClientSecret',
    <String, dynamic>{
      'atlasClientSecret': key,
    },
  );
}

Future<String?> getRestAPIKey() async {
  return await _globalChannel.invokeMethod('getRestAPIKey');
}

Future<String?> getAtlasClientId() async {
  return await _globalChannel.invokeMethod('getAtlasClientId');
}

Future<String?> getAtlasClientSecret() async {
  return await _globalChannel.invokeMethod('getAtlasClientSecret');
}

Future<String?> getMapSDKKey() async {
  return await _globalChannel.invokeMethod('getMapSDKKey');
}


Future<void> setShowLastSelectedStyle(bool showLastSelectedStyle) async {
  await _globalChannel.invokeMethod(
    'setShowLastSelectedStyle',
    <String, dynamic>{
      'showLastSelectedStyle': showLastSelectedStyle,
    },
  );
}

Future<bool> isShowLastSelectedStyle() async {
  return await _globalChannel.invokeMethod("isShowLastSelectedStyle");
}

Future<void> setDeveloperShowingSplash(bool developerShowingSplash) async {
  await _globalChannel.invokeMethod(
    'setDeveloperShowingSplash',
    <String, dynamic>{
      'developerShowingSplash': developerShowingSplash,
    },
  );
}

Future<bool> isDeveloperShowingSplash() async {
  return await _globalChannel.invokeMethod("isDeveloperShowingSplash");
}

Future<void> setClusterId(String? clusterId, {String? deviceAlias}) async {
  Map<String, dynamic> map = <String, dynamic>{
    'clusterId': clusterId,
  };
  if(deviceAlias != null) {
    map["deviceAlias"] = deviceAlias;
  }
  await _globalChannel.invokeMethod('setClusterId', map);
}

Future<String?> getClusterId() async {
  return await _globalChannel.invokeMethod("getClusterId");
}

Future<String?> getDeviceAlias() async {
  return await _globalChannel.invokeMethod("getDeviceAlias");
}

Future<void> setRegion(String? region) async {
  await _globalChannel.invokeMethod('setRegion', <String, dynamic>{
    'region': region
  });
}

Future<String?> getRegion() async {
  return await _globalChannel.invokeMethod("getRegion");
}

Future<void> setAssociationId(String? associationId) async {
  await _globalChannel.invokeMethod('setAssociationId', <String, dynamic>{
    'associationId': associationId
  });
}

Future<String?> getAssociationId() async {
  return await _globalChannel.invokeMethod("getAssociationId");
}